// Copyright (C) 2021-2024 Bundesministerium des Innern und für Heimat, Referat DG II 6, Maßnahmen Enterprise Resource Management und Elektronische Verwaltungsarbeit
//
// SPDX-License-Identifier: MPL-2.0

// tslint:disable
/**
 * eGesetzgebung Platform
 * This is the rest interface offered by the eGesetzgebung Platform backend.  Please provide __JW Access Token__ using button \'Authorize\' to access protected endpoints. Use the following instructions to get token:  1. on CMD/Bash/Terminal: ```curl -d \"client_id=user-management\" -d \"client_secret=INSERT_IAM_SECRET\" -d \"grant_type=password&username=INSERT_USER_EMAIL&password=INSERT_USER_PASSWORD\" \"INSERT_IAM_URL/realms/bund/protocol/openid-connect/token\"``` 2. copy access_token (without quotes, you can use jq or other tools to extract this value automatically) 3. insert value into \'JWToken\' field under \'Authorize\' and press \'Authorize\' 4. now you should have access to user protected endpoint  __FYI:__ token expires after 60 seconds. On non-production systems only a warning is displayed so you can work smoothly, but on production systems you have to frequently provide a new token.
 *
 * The version of the OpenAPI document: 9.0.3
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import type { Observable } from 'rxjs';
import type { AjaxResponse } from 'rxjs/ajax';
import { BaseAPI, throwIfNullOrUndefined, encodeURI } from '../runtime';
import type { OperationOpts, HttpHeaders } from '../runtime';
import type {
    EgfaModuleErfuellungsaufwandEntityDTO,
    EgfaModuleErfuellungsaufwandEntityResponseDTO,
    EgfaModuleErfuellungsaufwandTabellenDTO,
} from '../models';

export interface GetEgfaModule9Request {
    egfaId: string;
}

export interface ModifyEgfaModule9Request {
    egfaId: string;
    egfaModuleErfuellungsaufwandEntityDTO: EgfaModuleErfuellungsaufwandEntityDTO;
}

/**
 * no description
 */
export class EgfaModuleErfuellungsaufwandControllerApi extends BaseAPI {

    /**
     * Lädt die Tabellen für die Aufwandstabellen (bspw. Lohnkostentabelle)
     * GET TABELLEN
     */
    getEgfaErfuellungstabellen(): Observable<EgfaModuleErfuellungsaufwandTabellenDTO>
    getEgfaErfuellungstabellen(opts?: OperationOpts): Observable<AjaxResponse<EgfaModuleErfuellungsaufwandTabellenDTO>>
    getEgfaErfuellungstabellen(opts?: OperationOpts): Observable<EgfaModuleErfuellungsaufwandTabellenDTO | AjaxResponse<EgfaModuleErfuellungsaufwandTabellenDTO>> {
        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<EgfaModuleErfuellungsaufwandTabellenDTO>({
            url: '/egfamodules/erfuellungsaufwand/tabellen',
            method: 'GET',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Lädt ein Erfuellungsaufwand
     * GET ERFUELLUNGSAUFWANDMODUL
     */
    getEgfaModule9({ egfaId }: GetEgfaModule9Request): Observable<EgfaModuleErfuellungsaufwandEntityResponseDTO>
    getEgfaModule9({ egfaId }: GetEgfaModule9Request, opts?: OperationOpts): Observable<AjaxResponse<EgfaModuleErfuellungsaufwandEntityResponseDTO>>
    getEgfaModule9({ egfaId }: GetEgfaModule9Request, opts?: OperationOpts): Observable<EgfaModuleErfuellungsaufwandEntityResponseDTO | AjaxResponse<EgfaModuleErfuellungsaufwandEntityResponseDTO>> {
        throwIfNullOrUndefined(egfaId, 'egfaId', 'getEgfaModule9');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<EgfaModuleErfuellungsaufwandEntityResponseDTO>({
            url: '/egfamodules/erfuellungsaufwand/{egfaId}'.replace('{egfaId}', encodeURI(egfaId)),
            method: 'GET',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Ändert den Erfuellungsaufwandmodule
     * PUT ERFUELLUNGSAUFWANDMODUL
     */
    modifyEgfaModule9({ egfaId, egfaModuleErfuellungsaufwandEntityDTO }: ModifyEgfaModule9Request): Observable<EgfaModuleErfuellungsaufwandEntityResponseDTO>
    modifyEgfaModule9({ egfaId, egfaModuleErfuellungsaufwandEntityDTO }: ModifyEgfaModule9Request, opts?: OperationOpts): Observable<AjaxResponse<EgfaModuleErfuellungsaufwandEntityResponseDTO>>
    modifyEgfaModule9({ egfaId, egfaModuleErfuellungsaufwandEntityDTO }: ModifyEgfaModule9Request, opts?: OperationOpts): Observable<EgfaModuleErfuellungsaufwandEntityResponseDTO | AjaxResponse<EgfaModuleErfuellungsaufwandEntityResponseDTO>> {
        throwIfNullOrUndefined(egfaId, 'egfaId', 'modifyEgfaModule9');
        throwIfNullOrUndefined(egfaModuleErfuellungsaufwandEntityDTO, 'egfaModuleErfuellungsaufwandEntityDTO', 'modifyEgfaModule9');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<EgfaModuleErfuellungsaufwandEntityResponseDTO>({
            url: '/egfamodules/erfuellungsaufwand/{egfaId}'.replace('{egfaId}', encodeURI(egfaId)),
            method: 'PUT',
            headers,
            body: egfaModuleErfuellungsaufwandEntityDTO,
        }, opts?.responseOpts);
    };

}
